unit pjform;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, ogl_prender, U_3dos, GlobalVars, u_key, Menus;

type
  TPJediForm = class(TForm)
    Panel1: TPanel;
    Label2: TLabel;
    KeyList: TListBox;
    SBPCH: TScrollBar;
    LBAngle: TLabel;
    BNAddKey: TButton;
    Pbox: TPaintBox;
    Panel2: TPanel;
    SBFrame: TScrollBar;
    LBFrame: TLabel;
    EB3DO: TEdit;
    Label1: TLabel;
    BN3DO: TButton;
    BNPlay: TButton;
    BNStop: TButton;
    BNKeyDel: TButton;
    Label3: TLabel;
    Timer: TTimer;
    MainMenu: TMainMenu;
    File1: TMenuItem;
    Loada3DO1: TMenuItem;
    AddaKEY1: TMenuItem;
    Exit1: TMenuItem;
    Anim1: TMenuItem;
    Play1: TMenuItem;
    Stop1: TMenuItem;
    Options1: TMenuItem;
    Help1: TMenuItem;
    About1: TMenuItem;
    SBZoom: TScrollBar;
    Label4: TLabel;
    SetCMP1: TMenuItem;
    SBYAW: TScrollBar;
    procedure BN3DOClick(Sender: TObject);
    procedure SBPCHChange(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure BNAddKeyClick(Sender: TObject);
    procedure SBFrameChange(Sender: TObject);
    procedure KeyListClick(Sender: TObject);
    procedure PboxPaint(Sender: TObject);
    procedure TimerTimer(Sender: TObject);
    procedure BNPlayClick(Sender: TObject);
    procedure BNStopClick(Sender: TObject);
    procedure Loada3DO1Click(Sender: TObject);
    procedure AddaKEY1Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure Play1Click(Sender: TObject);
    procedure Stop1Click(Sender: TObject);
    procedure BNKeyDelClick(Sender: TObject);
    procedure Options1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure SBZoomChange(Sender: TObject);
    procedure SetCMP1Click(Sender: TObject);
  private
    { Private declarations }
    Rend:T3DORenderer;
    a3DO:T3DO;
    Procedure SetViewToThing;
    Procedure Redraw;
    Procedure WMEraseBkg(var msg:TMessage); message WM_ERASEBKGND;
    Function GetCurKEYFile:TKeyFile;
    Procedure GoToFrame;
    Procedure Load3DO(const name:string);
    Procedure LoadKey(const name:string);
  public
    { Public declarations }
  end;

var
  PJediForm: TPJediForm;

implementation

uses u_options, FileDialogs, FileOperations, Graph_Files;

{$R *.DFM}

Procedure TPJediForm.Load3DO(const name:string);
var s:string;
begin
 a3Do.Free;
 EB3DO.Text:=ExtractName(Name);
 a3DO:=T3DO.CreateFrom3DO(Name,0);

 if IsInContainer(name) then ProjectDir:='' else
  ProjectDir:=ExtractFilePath(Name);
 s:=ProjectDir;
 if s<>'' then
 begin
  SetLength(s,Length(s)-1);
  if CompareText(ExtractFileName(s),'3do')=0 then
  ProjectDir:=ExtractFilepath(s);
 end;

 Rend.LoadTextures(a3Do.mats);
 SetViewToThing;
 Redraw;
end;

procedure TPJediForm.BN3DOClick(Sender: TObject);
begin
 With GetFileOpen do
 begin
  Filter:='3DO&GOB Files|*.3do;*.gob;*.goo';
  If Execute then Load3DO(FileName);
 end;
end;

Procedure TPJediForm.SetViewToThing;
var bbox:TThingBox;
begin
 if a3DO=nil then exit;

 a3DO.OffsetMeshes;
 a3Do.GetBBox(bbox);
 rend.LookAtThing(bbox,SBPCH.position,SBYAW.position,SBZoom.Position/10);
 Redraw;
end;

procedure TPJediForm.SBPCHChange(Sender: TObject);
begin
 LBAngle.Caption:=Format('PCH: %d YAW: %d',[SBPCH.Position,SBYAW.Position]);
 SetViewToThing;
end;

procedure TPJediForm.SBZoomChange(Sender: TObject);
begin
 SetViewToThing;
end;

procedure TPJediForm.FormResize(Sender: TObject);
begin
 With PBox do
 Rend.SetViewPort(left,top,Width,Height);
end;

Procedure TPJediForm.LoadKEY(const name:string);
var kf:TKeyFile;
begin
 kf:=TKeyFile.CreateFromKey(Name);
 KeyList.Items.AddObject(ExtractFileName(Name),kf);
end;


procedure TPJediForm.BNAddKeyClick(Sender: TObject);
begin
 With GetFileOpen do
 begin
  Filter:='KEY&GOB Files|*.key;*.gob;*.goo';
  If Execute then LoadKEY(FileName);
 end;
end;

Procedure TPJediForm.GoToFrame;
var kf:TKeyFile;
begin
 if a3Do=nil then exit;
 kf:=getCurKEYFile;
 if kf=nil then exit;
 kf.ApplyKey(a3DO,SBFrame.position);
 redraw;
end;

procedure TPJediForm.SBFrameChange(Sender: TObject);
begin
 LBFrame.Caption:=IntToStr(SBFrame.Position);
 GotoFrame;
end;

Function TPJediForm.GetCurKEYFile:TKeyFile;
begin
 result:=nil;
 if KeyList.Items.Count=0 then exit;
 if KeyList.ItemIndex<0 then exit;
 result:=TKeyFile(KeyList.Items.Objects[KeyList.ItemIndex]);
end;

procedure TPJediForm.KeyListClick(Sender: TObject);
var kf:TKeyFile;
begin
 SBFrame.Min:=0;
 kf:=GetCurKeyFile;
 if kf=nil then exit;
 SBFrame.Max:=kf.nframes-1;
end;

Procedure TPJediForm.Redraw;
begin
 PBox.Invalidate;
end;

procedure TPJediForm.PboxPaint(Sender: TObject);
var i:integer;
begin
 Rend.BeginScene;
 if a3DO<>nil then
 begin
 { a3DO.OffsetMeshes;}
  for i:=0 to a3DO.Meshes.Count-1 do
   Rend.Draw3DOMesh(a3Do.Meshes[i]);
 end;
 Rend.EndScene;
end;

Procedure TPJediForm.WMEraseBkg(var msg:TMessage);
begin
 msg.Result:=0;
end;


procedure TPJediForm.TimerTimer(Sender: TObject);
var n:integer;
begin
 n:=SBFrame.Position;
 GotoFrame;
 if n=SBFrame.Max then n:=0 else inc(n);
 SBFrame.Position:=n;
end;

procedure TPJediForm.BNPlayClick(Sender: TObject);
var kf:TKeyFile;
begin
 kf:=GetCurKeyFile;
 if kf=nil then exit;
 Timer.Interval:=1000 div kf.fps;
 Timer.enabled:=true;
end;

procedure TPJediForm.BNStopClick(Sender: TObject);
begin
 Timer.enabled:=false;
end;

procedure TPJediForm.Loada3DO1Click(Sender: TObject);
begin
 BN3DO.Click;
end;

procedure TPJediForm.AddaKEY1Click(Sender: TObject);
begin
 BNAddKey.CLick;
end;

procedure TPJediForm.Exit1Click(Sender: TObject);
begin
 Application.Terminate;
end;

procedure TPJediForm.Play1Click(Sender: TObject);
begin
 BNPlay.Click;
end;

procedure TPJediForm.Stop1Click(Sender: TObject);
begin
 BNStop.Click;
end;

procedure TPJediForm.BNKeyDelClick(Sender: TObject);
var i:integer;
begin
 for i:=KeyList.Items.count-1 downto 0 do
 if KeyList.Selected[i] then
 begin
  KeyList.Items.Objects[i].Free;
  KeyList.Items.Delete(i);
 end;
 keyList.OnClick(KeyList);
end;

procedure TPJediForm.Options1Click(Sender: TObject);
begin
 Options.SetOptions;
end;

procedure TPJediForm.FormShow(Sender: TObject);
var i:integer;
begin
 Rend:=TOGLRenderer.Create(Handle);
 if ParamStr(1)<>'' then Load3DO(ParamStr(1));
 for i:=2 to ParamCount do
  LoadKey(paramStr(i));
end;

procedure TPJediForm.About1Click(Sender: TObject);
begin
 ShowMessage('Puppet Jedi version 0.11 - .3DO/.KEY animation player'#13#10+
             'for now, editor to be. (C) By Alexei Novikov, Code Alliance');
end;


procedure TPJediForm.SetCMP1Click(Sender: TObject);
begin
 With GetFileOpen do
 begin
  Filter:='CMP&GOB Files|*.cmp;*.gob;*.goo';
  If Execute then
  begin
   LoadCMPPal(FileName,CurrentPal);
   ApplyCMP(FileName,CurrentPal);
   if a3DO<>nil then Rend.LoadTextures(a3Do.mats);
   Redraw;
  end;
 end;
end;

end.
