unit u_Containers;

interface
Uses Files, Classes, SysUtils;
Type

TFInfo=TFileInfo;

{GOB2 declarations}
TGOB2Header=record
 Magic:array[0..3] of char; {='GOB'#20}
 Long1,long2:longint; { $14, $C}
 NEntries:longint;
end;

TGOB2Entry=record
 Pos,size:longint;
 name:array[0..127] of char;
end;

TGOB2Directory=class(TContainerFile)
 gh:TGob2Header;
 Procedure Refresh;override;
end;

implementation
Uses FileOperations;

{GOB2}
Procedure TGOB2Directory.Refresh;
var Fi:TFInfo;
    i:integer;
    ge:TGob2Entry;
    f:TFile;
    dir:string;
begin
 ClearIndex;
 f:=OpenFileRead(name,0);
Try
 F.FRead(gh,sizeof(gh));
 if gh.magic<>'GOB ' then raise Exception.Create(Name+' is not a GOB 2.0 file');
 for i:=0 to gh.NEntries-1 do
 begin
  F.FRead(ge,sizeof(ge));
  fi:=TFInfo.Create;
  fi.offs:=ge.pos;
  fi.size:=ge.size;
  Files.AddObject(ge.name,fi);
  Dir:=ExtractFilePath(ge.name);
  if dir<>'' then
  begin
   If Dir[Length(Dir)]='\' then SetLength(Dir,Length(Dir)-1);
   if Dirs.IndexOf(Dir)=-1 then Dirs.Add(Dir);
  end;
 end;
Finally
 F.FClose;
end;
end;

end.
