unit u_options;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, GlobalVars, Registry;

type
  TOptions = class(TForm)
    Panel1: TPanel;
    BNOK: TButton;
    Label1: TLabel;
    EBJKGOB: TEdit;
    Label2: TLabel;
    EBMOTSGOB: TEdit;
    BNJK: TButton;
    BNMOTS: TButton;
    OpenJKGOB: TOpenDialog;
    OpenMOTSGOB: TOpenDialog;
    procedure BNJKClick(Sender: TObject);
    procedure BNMOTSClick(Sender: TObject);
    procedure BNOKClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
   Function SetOptions:boolean;
  end;

var
  Options: TOptions;
  NoRegEntry:boolean;
  
implementation

{$R *.DFM}

procedure TOptions.BNJKClick(Sender: TObject);
begin
 With OpenJKGOB do
 begin
  FileName:=EBJKGOB.Text;
  If not execute then exit;
  EBJKGOB.Text:=FileName;
 end;
end;

procedure TOptions.BNMOTSClick(Sender: TObject);
begin
 With OpenMOTSGOB do
 begin
  FileName:=EBMOTSGOB.Text;
  If not execute then exit;
  EBMOTSGOB.Text:=FileName;
 end;
end;

Function TOptions.SetOptions:boolean;
var reg:TRegistry;
begin
 Result:=false;
 EBJKGOB.Text:=res2_gob;
 EBMOTSGOB.Text:=jkmres_gob;
 if ShowModal<>mrOK then exit;
 res2_gob:=EBJKGOB.Text;
 jkmres_gob:=EBMOTSGOB.Text;

 Reg:=TRegistry.Create;
 Reg.OpenKey(RegBase,true);
 reg.WriteString('JKGOB',res2_gob);
 reg.WriteString('MOTSGOB',jkmres_gob);
 Reg.Free;
 Result:=true;
end;

procedure TOptions.BNOKClick(Sender: TObject);
begin
 if (EBJKGOB.Text<>'') and (Not FileExists(EBJKGOB.Text)) then
 begin
  ShowMessage(EBJKGOB.Text+' does no exist!');
  exit;
 end;
 if (EBMOTSGOB.Text<>'') and (Not FileExists(EBMOTSGOB.Text)) then
 begin
  ShowMessage(EBMOTSGOB.Text+' does no exist!');
  exit;
 end;
 ModalResult:=mrOK;
 hide;
end;

procedure TOptions.FormCreate(Sender: TObject);
begin
 If NoRegEntry then
  if SetOptions then exit;
end;

var Reg:TRegistry;
    dir:string;

Initialization
begin
 Reg:=TRegistry.Create;
 NoRegEntry:=not Reg.OpenKey(RegBase,false);
 if not NoRegEntry then
 begin
  res2_gob:=Reg.ReadString('JKGOB');
  jkmres_gob:=Reg.ReadString('MOTSGOB');
 end;

 reg.CloseKey;
 if Reg.OpenKey(JedRegBase,false) then
 begin
  dir:=Reg.ReadString('JKDIR');
  res2_gob:=dir+'Resource\res2.gob';
  dir:=Reg.ReadString('MOTSDIR');
  jkmres_gob:=dir+'Resource\jkmres.goo';
 end;
 reg.Free;
end;

end.
